# -*- coding: utf-8 -*-
from setuphelpers import *

# registry key(s) where WAPT will find how to remove the application(s)
uninstallkey = []

""" You can do a CTRL F9 in pyscripter to update the package """

def install():

    install_msi_if_needed('PaintDotNet_x86.msi',killbefore=['PaintDotNet.exe'])
    remove_desktop_shortcut('paint.net')


def update_package():
    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    currentpath = os.path.dirname(os.path.realpath(__file__))

    """I retrieve the current version from the official site >>>"""
    htmlSource = ensure_unicode(wgets("http://www.getpaint.net/roadmap.html",proxies=proxies)).splitlines()
    for line in htmlSource :
        if 'released' in line :
            if 'paint.net' in line :
                start = line.find("paint.net")
                startversion = start + 10
                end = line.find("</strong>")
                realversion = line[startversion:end]
                break

    """
    I list all the msi file of the package and test the msi version
    if the version returned by the msi does not correspond to the previous one, I delete the file
    >>>
    """

    allmsi = glob.glob('*.msi')
    for msi in allmsi:
        vers = get_msi_properties(msi)['ProductVersion']
        if  vers != realversion :
            remove_file(msi)

    if not isfile('PaintDotNet_x64.msi'):

        """I download the file if it does not exist >>>"""
        wget('http://www.dotpdn.com/files/paint.net.%s.install.zip' % realversion, 'paintnet.zip',proxies=proxies)


        """Unzip file >>>"""
        unzip('paintnet.zip','paintfolder')

        """Delete zip >>>"""
        remove_file('paintnet.zip')

        """Run create Msi >>>"""
        run(makepath('paintfolder','paint.net.%s.install.exe' % realversion) + " /createmsi")

        """Delete Folder >>>"""
        remove_tree('paintfolder')

        """Copy msi file in wapt package >>>"""
        msipaint = glob.glob(makepath(user_desktop(),'PaintDotNetMsi','*_x86.msi'))
        for paint in msipaint :
            filecopyto(paint,currentpath)

        remove_tree(makepath(user_desktop(),'PaintDotNetMsi'))

    """I write the version in the control file >>>"""

    control.version = get_msi_properties('PaintDotNet_x86.msi')['ProductVersion'] + '-0'
    control.save_control_to_wapt()

    """Clean folder on desktop >>>"""
